/********************************************************************* 
-- S+ sparse GE solver (version 1.1) --

Copyright (C) 1999 by University of California at Santa Barbara. 
Copyright (C) 2005 by University of Rochester. 
All rights reserved.

S+ team contact: Kai Shen <kshen@cs.rochester.edu>, 
                 Tao Yang <tyang@cs.ucsb.edu>  

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose, without fee, and without written agreement
is hereby granted, provided that the above copyright notice and the
following paragraph appear in all copies of this software.

This software is provided ``as is'', without any warranty, including 
any implied warranty for merchantability or fitness for a particular
purpose. Under no circumstances shall the University of California at 
Santa Barbara, the University of Rochester, or their agents be liable 
for any use of, misuse of, or inability to use this software, including 
incidental and consequential damages.
************************************************************************/

/*
 * globals.h - global variables declaration
 *
 */


#ifndef __GLOBALS_H_
#define __GLOBALS_H_

#include <stdio.h>
#include <stdarg.h>

#include "struct.h"

/* fortran char descriptors, required by calling blas subroutines */
extern _fcd SP_ftcL, SP_ftcU, SP_ftcN;

extern int SP_BlkSize;
extern double SP_Relax;
extern double SP_DenseThresh;
extern double SP_Epsilon;
extern double SP_EpsilonBPratio;
extern double SP_PivotThresh;           /* threshold for threshold pivoting, <=1.0 */
extern int SP_BatchPivot;               /* 1 - batch pivoting, 0 - serial pivoting */
extern int SP_BatchPivotBailout;        /* the number of times batch pivoting has to bail out */

extern int SP_me_no, SP_nproc;		/* my PE id and total PE numbers */
extern int SP_rp, SP_cp;		/* the processors are viewed as a 2-D mesh rp x cp*/
extern int SP_me_rno, SP_me_cno;	/* the 2-D coordinates of this processor   */

void SP_err(char *file, int line, char *format, ...);

#endif
